## openturns 1.0

=== CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

cmake_minimum_required ( VERSION 2.8 )

project ( OpenTURNS CXX C Fortran )

option ( USE_BISON "Looks for Bison if true and then build parser" ON )
option ( USE_FLEX  "Looks for Flex if true and then build lexer" ON )
option ( USE_TBB   "Use Intel Threading Building Blocks library for multithreading" ON )

# Defines our own module path
set ( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMakeModules" ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY} )

# Find system prerequisites
include ( CMakeDetermineCXXCompiler )
include ( CMakeDetermineCCompiler )
include ( CMakeDetermineFortranCompiler )
include ( CMakeTestFortranCompiler )
include ( CheckIncludeFile )
include ( CMakeFortranCompiler )

if ( USE_BISON )
  find_package ( BISON REQUIRED )
endif ( USE_BISON )

if ( USE_FLEX )
  find_package ( FLEX REQUIRED )
endif ( USE_FLEX )

if ( USE_TBB )
  find_package ( TBB )
endif ()

find_package ( BLAS )
find_package ( LAPACK )
find_package ( Doxygen )
find_package ( LibXml2 )
find_package ( Threads )
find_package ( Libdl )
find_package ( Regex )
find_package ( R COMPONENTS base rotRPackage REQUIRED )

find_program ( RM_EXECUTABLE
               NAMES rm rem del delete
	       DOC "Path to the system remove command"
	     )
mark_as_advanced ( RM_EXECUTABLE )
check_include_file ( arpa/inet.h   HAVE_ARPA_INET_H   )
check_include_file ( assert.h      HAVE_ASSERT_H      )
check_include_file ( dirent.h      HAVE_DIRENT_H      )
check_include_file ( errno.h       HAVE_ERRNO_H       )
check_include_file ( inttypes.h    HAVE_INTTYPES_H    )
check_include_file ( math.h        HAVE_MATH_H        )
check_include_file ( netdb.h       HAVE_NETDB_H       )
check_include_file ( netinet/in.h  HAVE_NETINET_IN_H  )
check_include_file ( netinet/tcp.h HAVE_NETINET_TCP_H )
check_include_file ( pthread.h     HAVE_PTHREAD_H     )
check_include_file ( regex.h       HAVE_REGEX_H       )
check_include_file ( semaphore.h   HAVE_SEMAPHORE_H   )
check_include_file ( signal.h      HAVE_SIGNAL_H      )
check_include_file ( stdbool.h     HAVE_STDBOOL_H     )
check_include_file ( stdint.h      HAVE_STDINT_H      )
check_include_file ( stdlib.h      HAVE_STDLIB_H      )
check_include_file ( string.h      HAVE_STRING_H      )
check_include_file ( strings.h     HAVE_STRINGS_H     )
check_include_file ( sys/socket.h  HAVE_SYS_SOCKET_H  )
check_include_file ( sys/stat.h    HAVE_SYS_STAT_H    )
check_include_file ( sys/time.h    HAVE_SYS_TIME_H    )
check_include_file ( sys/types.h   HAVE_SYS_TYPES_H   )
check_include_file ( sys/un.h      HAVE_SYS_UN_H      )
check_include_file ( unistd.h      HAVE_UNISTD_H      )


# Some useful macros to ease CMakeLists.txt file writing
set ( SOURCEFILES "" CACHE INTERNAL "List of source files to compile" )
macro ( ot_add_source_file FILENAME )
  set ( sf ${SOURCEFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME} )
  set ( SOURCEFILES ${sf} CACHE INTERNAL "List of source files to compile" )
endmacro ( ot_add_source_file )

set ( BUILT_SOURCEFILES "" CACHE INTERNAL "List of source files to compile" )
macro ( ot_add_built_source_file FILENAME )
  set ( sf ${BUILT_SOURCEFILES} ${FILENAME} )
  set ( BUILT_SOURCEFILES ${sf} CACHE INTERNAL "List of built source files to compile" )
endmacro ( ot_add_built_source_file )

set ( HEADERFILES "" CACHE INTERNAL "List of header files to install" )
macro ( ot_install_header_file FILENAME )
  set ( hf ${HEADERFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME} )
  set ( HEADERFILES ${hf} CACHE INTERNAL "List of header files to install" )
endmacro ( ot_install_header_file )

set ( SWIGFILES "" CACHE INTERNAL "List of SWIG files to install" )
macro ( ot_install_swig_file FILENAME )
  set ( hf ${SWIGFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME} )
  set ( SWIGFILES ${hf} CACHE INTERNAL "List of SWIG files to install" )
endmacro ( ot_install_swig_file )

set ( INTERNAL_INCLUDE_DIRS "" CACHE INTERNAL "List of directories with header files needed for build" )
macro ( ot_add_current_dir_to_include_dirs )
  set ( inc_dirs ${INTERNAL_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR} )
  set ( INTERNAL_INCLUDE_DIRS ${inc_dirs} CACHE INTERNAL "List of directories with header files needed for build" )
endmacro ( ot_add_current_dir_to_include_dirs )
macro ( ot_add_build_dir_to_include_dirs DIR )
  set ( inc_dirs ${INTERNAL_INCLUDE_DIRS} ${DIR} )
  set ( INTERNAL_INCLUDE_DIRS ${inc_dirs} CACHE INTERNAL "List of directories with header files needed for build" )
endmacro ( ot_add_build_dir_to_include_dirs )


# Add definitions according to the prerequisites found
add_definitions ( -DHAVE_CONFIG_H )
if ( LIBXML2_FOUND )
  set ( HAVE_LIBXML2 TRUE )
  add_definitions ( ${LIBXML2_DEFINITIONS} )
  #include_directories ( ${LIBXML2_INCLUDE_DIR} )
  ot_add_build_dir_to_include_dirs ( ${LIBXML2_INCLUDE_DIR} )
  set ( OPENTURNS_DEFINITIONS ${OPENTURNS_DEFINITIONS} ${LIBXML2_DEFINITIONS} )
  set ( OPENTURNS_INCLUDE     ${OPENTURNS_INCLUDE}     ${LIBXML2_INCLUDE_DIR} )
endif ( LIBXML2_FOUND )


if ( Threads_FOUND )
  add_definitions ( -pthread )
endif ( Threads_FOUND )

if ( TBB_FOUND )
  set ( HAVE_TBB TRUE )
  set ( HAVE_TBB_TBB_H TRUE )
  include_directories ( ${TBB_INCLUDE_DIRS} )
endif ( TBB_FOUND )

if ( LIBDL_FOUND )
  set ( HAVE_LIBDL TRUE )
  include_directories ( ${LIBDL_INCLUDE_DIR} )
endif ( LIBDL_FOUND )

if ( REGEX_FOUND )
  set ( HAVE_REGEX TRUE )
  include_directories ( ${REGEX_INCLUDE_DIR} )
endif ( REGEX_FOUND )

set ( CPACK_PACKAGE_NAME          openturns      )
set ( CPACK_PACKAGE_VERSION_MAJOR 1              )
set ( CPACK_PACKAGE_VERSION_MINOR 0 )
set ( CPACK_PACKAGE_VERSION_PATCH                )
set ( CPACK_SOURCE_GENERATOR      "TGZ;TBZ2"     )
set ( CPACK_BINARY_STGZ           "OFF"          )
set ( CPACK_BINARY_TBZ2           "ON"           )
set ( CPACK_BINARY_TGZ            "ON"           )
set ( CPACK_BINARY_TZ             "OFF"          )
set ( CPACK_SOURCE_IGNORE_FILES "/.svn;/build;.*~;${CPACK_SOURCE_IGNORE_FILES}" )
#set ( CPACK_INSTALL_CMAKE_PROJECTS "lib;OpenTURNSLib;ALL;/" "python;OpenTURNSPython;ALL;/" )


# Set global definitions
# TODO: remove PACKAGE_<XX> from source code. Needed for compatibility with autotools
set ( PACKAGE_NAME           ${CPACK_PACKAGE_NAME} )
set ( PACKAGE_VERSION        ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR} )
if ( CPACK_PACKAGE_VERSION_PATCH )
  set ( PACKAGE_VERSION       ${PACKAGE_VERSION}.${CPACK_PACKAGE_VERSION_PATCH} )
endif ( CPACK_PACKAGE_VERSION_PATCH )
set ( PACKAGE_BUGREPORT      bugs@openturns.org )
set( CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_NAME}-${PACKAGE_VERSION} )

# uninstall target
configure_file (
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY
)

add_custom_target ( uninstall
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

# distcheck target
find_program( TAR_PROGRAM tar ) 
get_filename_component( BUILD_TOOL_NAME ${CMAKE_BUILD_TOOL} NAME )
if ( TAR_PROGRAM AND BUILD_TOOL_NAME MATCHES ".*make" )
  set ( DISTCHECK_BINARY_DIR ${CMAKE_BINARY_DIR}/${CPACK_SOURCE_PACKAGE_FILE_NAME}/_build )
  set ( DISTCHECK_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/${CPACK_SOURCE_PACKAGE_FILE_NAME}/_inst )
  add_custom_target ( distcheck 
    COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_BINARY_DIR} "$(MAKE)" package_source
    COMMAND ${CMAKE_COMMAND} -E remove_directory ${DISTCHECK_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E remove_directory ${DISTCHECK_INSTALL_PREFIX}
    COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_BINARY_DIR} ${TAR_PROGRAM} xvfz ${CMAKE_BINARY_DIR}/${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz
    COMMAND ${CMAKE_COMMAND} -E make_directory ${DISTCHECK_BINARY_DIR}
    COMMAND ${CMAKE_COMMAND} -E make_directory ${DISTCHECK_INSTALL_PREFIX}
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} ${CMAKE_COMMAND} .. -DCMAKE_INSTALL_PREFIX=${DISTCHECK_INSTALL_PREFIX}
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)"
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)" check
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)" install
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)" cppinstallcheck
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)" pyinstallcheck
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)" uninstall
    COMMAND ${CMAKE_COMMAND} -E chdir ${DISTCHECK_BINARY_DIR} "$(MAKE)" clean
  )
endif ()

set ( OPENTURNS_HOME_ENV_VAR OPENTURNS_HOME     )
set ( OPENTURNS_INSTALL_PATH
      ${CMAKE_INSTALL_PREFIX}
      CACHE PATH "The directory where Open TURNS is installed"
    )

# automatically set lib suffix
if ( UNIX AND NOT APPLE AND NOT CMAKE_CROSSCOMPILING AND NOT EXISTS "/etc/debian_version" )
  if ( CMAKE_SIZEOF_VOID_P EQUAL 8 AND NOT LIB_SUFFIX )
    set ( LIB_SUFFIX 64 )
  endif ()
endif ()

set ( OPENTURNS_LIBRARY_PATH
      lib${LIB_SUFFIX}/openturns
      CACHE PATH "The directory where the library is installed"
    )
set ( OPENTURNS_INCLUDE_PATH
      include/openturns
      CACHE PATH "The directory where the header files are installed"
    )
set ( OPENTURNS_SYSCONFIG_PATH
      etc
      CACHE PATH "The directory where the configuration file is installed"
    )
set ( OPENTURNS_DATA_PATH
      share
      CACHE PATH "The directory where the common files are installed"
    )
set ( OPENTURNS_WRAPPER_PATH
      lib${LIB_SUFFIX}/openturns/wrappers
      CACHE PATH "The directory where the wrapper files are installed"
    )
set ( OPENTURNS_EXAMPLE_PATH
      share/openturns/examples
      CACHE PATH "The directory where the example files are installed"
    )
set ( OPENTURNS_SAMPLE_PATH
      share/openturns/examples
      CACHE PATH "The directory where the sample files are installed"
    )
set ( OPENTURNS_VALIDATION_PATH
      share/openturns/validation
      CACHE PATH "The directory where validation files are installed"
    )
set ( OPENTURNS_DOC_PATH
      share/openturns/doc
      CACHE PATH "The directory where the license files are installed"
    )
set ( OPENTURNS_TEMPDIR
      /tmp
      CACHE PATH "The directory for temporary files. /tmp by default."
    )

# WARNING: This is where variables without OPENTURNS_ prefix are defined !
foreach ( _var INSTALL_PATH LIBRARY_PATH INCLUDE_PATH SYSCONFIG_PATH DATA_PATH WRAPPER_PATH EXAMPLE_PATH SAMPLE_PATH VALIDATION_PATH DOC_PATH TEMPDIR )
  if ( IS_ABSOLUTE ${OPENTURNS_${_var}} )
    set(${_var} ${OPENTURNS_${_var}})
  else ( IS_ABSOLUTE ${OPENTURNS_${_var}} )
    set(${_var} ${OPENTURNS_INSTALL_PATH}/${OPENTURNS_${_var}})
  endif ( IS_ABSOLUTE ${OPENTURNS_${_var}} )
endforeach ( _var )

# Selectively add or remove RPATH from executable
set ( OPENTURNS_SYSTEM_INSTALL OFF CACHE BOOL "True if Open TURNS is installed in a system directory. RPATH removed. False by default." )
if ( NOT OPENTURNS_SYSTEM_INSTALL )
  set ( CMAKE_INSTALL_RPATH ${LIBRARY_PATH}

=== lib/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

#project ( OpenTURNSLib CXX C Fortran )

# Recurse in subdirectories
add_subdirectory ( include )
add_subdirectory ( src )
add_subdirectory ( etc )

# Build the OpenTURNSConfig.cmake file
get_target_property ( OPENTURNS_LIBRARY_LOC OT LOCATION )
get_filename_component ( OPENTURNS_INSTALL_LIBRARY ${OPENTURNS_LIBRARY_LOC} NAME )
set ( OPENTURNS_LIBRARY_DIRS   ${LIBRARY_PATH} )
set ( OPENTURNS_LIBRARY        ${LIBRARY_PATH}/${OPENTURNS_INSTALL_LIBRARY} )
set ( OPENTURNS_INCLUDE        ${INCLUDE_PATH} )
set ( OPENTURNS_DEFINITIONS    "" )
set ( OPENTURNS_ROOT_DIR       ${INSTALL_PATH} )
set ( OPENTURNS_VERSION_STRING ${PACKAGE_VERSION} )
set ( OPENTURNS_VERSION_MAJOR  ${CPACK_PACKAGE_VERSION_MAJOR} )
set ( OPENTURNS_VERSION_MINOR  ${CPACK_PACKAGE_VERSION_MINOR} )
set ( OPENTURNS_VERSION_PATCH  ${CPACK_PACKAGE_VERSION_PATCH} )
set ( OPENTURNS_USE_FILE       ${LIBRARY_PATH}/OpenTURNSUse.cmake )

configure_file ( ${PROJECT_SOURCE_DIR}/lib/OpenTURNSConfig.cmake.in
                 ${PROJECT_BINARY_DIR}/lib/OpenTURNSConfig.cmake
		 @ONLY
               )
install ( FILES ${PROJECT_SOURCE_DIR}/lib/OpenTURNSUse.cmake
                ${PROJECT_BINARY_DIR}/lib/OpenTURNSConfig.cmake
          DESTINATION ${OPENTURNS_LIBRARY_PATH}
        )

install ( FILES AUTHORS
                COPYING
		COPYING.MuParser
		COPYING.cobyla
		COPYING.dsfmt
		COPYING.lapack
		COPYING.tnc
		COPYING.kissfft
		ChangeLog
		INSTALL
		NEWS
		README
		TODO
	  DESTINATION ${OPENTURNS_DOC_PATH}
        )

# Recurse in subdirectories : Test should be run after src (for  target OT to be built)
add_subdirectory ( test )

=== python/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

#project ( OpenTURNSPython CXX )

include_directories ( ${PYTHON_INCLUDE_DIRS} )

# Recurse in subdirectories
add_subdirectory ( src )
add_subdirectory ( test )

=== utils/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

=== validation/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

add_subdirectory ( src )

=== wrappers/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

install ( DIRECTORY WrapperTemplates
          DESTINATION ${OPENTURNS_DATA_PATH}/openturns
	  PATTERN *~   EXCLUDE
	  PATTERN .svn EXCLUDE
        )

=== lib/etc/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

# TODO: These variables are needed for autotools compatibility
set ( r_prog_path ${R_EXECUTABLE} )
set ( temporary_directory ${TEMPDIR} )

configure_file ( ${CMAKE_CURRENT_SOURCE_DIR}/openturns.conf.in
                 ${CMAKE_CURRENT_BINARY_DIR}/openturns.conf
		 @ONLY )

install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/openturns.conf
          DESTINATION etc/openturns
	  PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
	)

=== lib/include/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

include ( FortranCInterface )
FortranCInterface_HEADER ( FortranCInterface.h )

ot_add_current_dir_to_include_dirs ()
ot_add_build_dir_to_include_dirs ( ${CMAKE_CURRENT_BINARY_DIR} )

configure_file ( ${CMAKE_CURRENT_SOURCE_DIR}/OTconfig.h.cmake.in
                 ${CMAKE_CURRENT_BINARY_DIR}/OTconfig.h
		 @ONLY
               )

configure_file ( ${CMAKE_CURRENT_SOURCE_DIR}/OTconfigure_args.hxx.in
                 ${CMAKE_CURRENT_BINARY_DIR}/OTconfigureArgs.hxx
		 @ONLY
               )

install ( FILES OTconfig.hxx
                OTdebug.h
		OTmemory.hxx
		OTprivate.hxx
		OTtestcode.hxx
		OTthread.hxx
		OTtypes.hxx
		${CMAKE_CURRENT_BINARY_DIR}/OTconfig.h
          DESTINATION ${OPENTURNS_INCLUDE_PATH}
	  PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
        )


#get_cmake_property ( VARS VARIABLES )
#foreach ( var ${VARS} )
#  file( APPEND ${CMAKE_CURRENT_BINARY_DIR}/VARS.txt
#        "${var} \"${${var}}\"\n" )
#endforeach ( var )

=== lib/src/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

# Register current directory files
ot_add_current_dir_to_include_dirs ()
ot_install_header_file ( OT.hxx )
ot_add_source_file ( openturns_library_ok.c )

foreach ( include_dir ${INTERNAL_INCLUDE_DIRS} )
  set ( EXTRA_CPPFLAGS "${EXTRA_CPPFLAGS} -I${include_dir}" )
endforeach ()
configure_file ( ${CMAKE_CURRENT_SOURCE_DIR}/openturns-config-build.cmake.in
                 ${CMAKE_CURRENT_BINARY_DIR}/openturns-config-build
                 @ONLY
               )
configure_file ( ${CMAKE_CURRENT_SOURCE_DIR}/openturns-module-build.in
                 ${CMAKE_CURRENT_BINARY_DIR}/openturns-module-build
                 @ONLY
               )
install ( PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/openturns-config-build
          DESTINATION ${INSTALL_PATH}/bin
          RENAME openturns-config
        )
install ( PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/openturns-module-build
          DESTINATION ${INSTALL_PATH}/bin
          RENAME openturns-module
        )

# Recurse in subdirectories
add_subdirectory ( Base )
add_subdirectory ( Uncertainty )
if ( NOT LAPACK_FOUND AND NOT BLAS_FOUND )
  add_subdirectory ( BlasLapack )
endif ( NOT LAPACK_FOUND AND NOT BLAS_FOUND )

# Build main library
foreach ( built_source ${BUILT_SOURCEFILES} )
  set_source_files_properties ( ${built_source} PROPERTIES GENERATED TRUE )
endforeach ( built_source )
include_directories ( ${INTERNAL_INCLUDE_DIRS} )
link_directories ( ${CMAKE_Fortran_IMPLICIT_LINK_DIRECTORIES} )
add_library ( OTbind SHARED bind.c )
add_library ( OT SHARED ${SOURCEFILES} ${BUILT_SOURCEFILES} )
set_target_properties ( OT OTbind PROPERTIES SOVERSION 0 )
set_target_properties ( OT OTbind PROPERTIES VERSION 0.0.0 )
if ( BISON_FOUND )
  add_dependencies ( OT generate_csv_parser )
endif ( BISON_FOUND )
if ( FLEX_FOUND )
  add_dependencies ( OT generate_csv_lexer  )
endif ( FLEX_FOUND )
target_link_libraries( OT ${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES} )

if ( APPLE ) # CMake Makefiles don't link against stdc++ on osx
  target_link_libraries( OTbind stdc++)
  target_link_libraries( OT stdc++)
endif ( APPLE )

# Add external dependencies to the library
if (LIBXML2_FOUND)
  target_link_libraries ( OT ${LIBXML2_LIBRARIES} )
endif (LIBXML2_FOUND)

if ( LAPACK_FOUND )
  target_link_libraries ( OT ${LAPACK_LIBRARIES} )
endif ( LAPACK_FOUND )

if ( Threads_FOUND )
  target_link_libraries ( OT ${CMAKE_THREAD_LIBS_INIT} )
endif ( Threads_FOUND )

if ( TBB_FOUND )
  target_link_libraries ( OT ${TBB_LIBRARIES} )
endif ( TBB_FOUND )

if (LIBDL_FOUND)
  target_link_libraries ( OT ${LIBDL_LIBRARIES} )
endif (LIBDL_FOUND)

if (REGEX_FOUND)
  target_link_libraries ( OT ${REGEX_LIBRARIES} )
endif (REGEX_FOUND)

# Build an empty executable to check link dependencies and completeness
add_executable ( linktest main.cxx )
target_link_libraries ( linktest OT )
set_target_properties ( linktest PROPERTIES
                                 INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${CMAKE_BINARY_DIR}/lib/src" )


# Install rules for library and executable
install ( TARGETS OT OTbind
          RUNTIME DESTINATION bin
          LIBRARY DESTINATION ${LIBRARY_PATH}
          ARCHIVE DESTINATION ${LIBRARY_PATH}
        )

#foreach ( file ${SOURCEFILES} )
#  message ( ">> Will compile ${file}" )
#endforeach ( file )

#foreach ( file ${BUILT_SOURCEFILES} )
#  message ( ">> Will compile built ${file}" )
#endforeach ( file )

#foreach ( file ${HEADERFILES} )
#  message ( ">> Will install ${file}" )
#endforeach ( file )

#get_cmake_property ( VARS VARIABLES )
#foreach ( var ${VARS} )
#  file( APPEND ${CMAKE_CURRENT_BINARY_DIR}/VARS.txt
#        "${var} \"${${var}}\"\n" )
#endforeach ( var )

=== lib/test/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

cmake_minimum_required ( VERSION 2.8 )

#include ( CTest )

set ( NEW_PATH "$ENV{PATH}:${EXAMPLE_PATH}" )

set ( CHECK_ENVIRONMENT "OPENTURNS_CONFIG_PATH=${CMAKE_BINARY_DIR}/lib/etc" )

set ( INSTALLCHECK_ENVIRONMENT "OPENTURNS_WRAPPER_PATH=${WRAPPER_PATH}"
                               "OPENTURNS_CONFIG_PATH=${SYSCONFIG_PATH}/openturns"
                               "OPENTURNS_NUMERICALSAMPLE_PATH=${SAMPLE_PATH}"
                               "PATH=${NEW_PATH}"
    )

# This macro compiles on the fly and run the corresponding pre-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set ( CHECK_TO_BE_RUN )
macro ( ot_check_test TESTNAME )
  set ( TESTNAME_TGT t_${TESTNAME} )
  set ( TESTNAME_SRC ${TESTNAME_TGT}.cxx )
  set ( TESTNAME_OUT ${TESTNAME_TGT}.expout )
  get_source_file_property ( OUTFILE_LOC ${TESTNAME_OUT} LOCATION )
  add_executable ( ${TESTNAME_TGT} EXCLUDE_FROM_ALL ${TESTNAME_SRC} )
  target_link_libraries ( ${TESTNAME_TGT} OT )
  set_target_properties ( ${TESTNAME_TGT} PROPERTIES
                                          INSTALL_RPATH "${CMAKE_BINARY_DIR}/lib/src;${CMAKE_INSTALL_RPATH}" )
  get_target_property ( TESTNAME_LOC ${TESTNAME_TGT} LOCATION )

  set ( _CMD )
  set ( _PRE )
  set ( _POST )
  set ( _PARAMS )
  set ( _IGNOREOUT OFF )
  foreach ( _ARG ${ARGN} )
    string ( TOUPPER ${_ARG} ARG )
    if ( ${ARG} MATCHES PRE )
      set ( _CMD PRE )
    elseif ( ${ARG} MATCHES POST )
      set ( _CMD POST )
    elseif ( ${ARG} MATCHES PARAMS )
      set ( _CMD PARAMS )
    elseif ( ${ARG} MATCHES IGNOREOUT )
      set ( _IGNOREOUT ON )
    else ( ${ARG} MATCHES PRE )
      if ( ${_CMD} MATCHES PRE )
        set ( _PRE "${_PRE} ${_ARG} && " )
      elseif ( ${_CMD} MATCHES POST )
        set ( _POST "${_POST} && ${_ARG}" )
      elseif ( ${_CMD} MATCHES PARAMS )
        set ( _PARAMS "${_PARAMS} ${_ARG}" )
      endif  ( ${_CMD} MATCHES PRE )
      set ( _CMD )
    endif ( ${ARG} MATCHES PRE )
  endforeach ( _ARG )

  if (_IGNOREOUT)
    set ( COMMAND "( ${TESTNAME_LOC} ${_PARAMS} > /dev/null )" )
  else (_IGNOREOUT)
    set ( COMMAND "( ${TESTNAME_LOC} ${_PARAMS} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out ) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out" )
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    add_test ( cppcheck_${TESTNAME} "sh" "-c" "${_PRE}${COMMAND}${_POST}" )
  else (_PRE OR _POST)
    add_test ( cppcheck_${TESTNAME} "sh" "-c" "${COMMAND}" )
  endif (_PRE OR _POST)
  set_tests_properties ( cppcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${CHECK_ENVIRONMENT}" )
  list ( APPEND CHECK_TO_BE_RUN ${TESTNAME_TGT} )
  install ( FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH} 
            PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
          )
endmacro ( ot_check_test )

# This macro compiles on the fly and run the corresponding post-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set ( INSTALLCHECK_TO_BE_RUN )
macro ( ot_installcheck_test TESTNAME )
  set ( TESTNAME_TGT t_${TESTNAME} )
  set ( TESTNAME_SRC ${TESTNAME_TGT}.cxx )
  set ( TESTNAME_OUT ${TESTNAME_TGT}.expout )
  get_source_file_property ( OUTFILE_LOC ${TESTNAME_OUT} LOCATION )
  add_executable ( ${TESTNAME_TGT} EXCLUDE_FROM_ALL ${TESTNAME_SRC} )
  target_link_libraries ( ${TESTNAME_TGT} OT )
  get_target_property ( TESTNAME_LOC ${TESTNAME_TGT} LOCATION )

  set ( _CMD )
  set ( _PRE )
  set ( _POST )
  set ( _PARAMS )
  set ( _IGNOREOUT OFF )
  foreach ( _ARG ${ARGN} )
    string ( TOUPPER ${_ARG} ARG )
    if ( ${ARG} MATCHES PRE )
      set ( _CMD PRE )
    elseif ( ${ARG} MATCHES POST )
      set ( _CMD POST )
    elseif ( ${ARG} MATCHES PARAMS )
      set ( _CMD PARAMS )
    elseif ( ${ARG} MATCHES IGNOREOUT )
      set ( _IGNOREOUT ON )
    else ( ${ARG} MATCHES PRE )
      if ( ${_CMD} MATCHES PRE )
        set ( _PRE "${_PRE} ${_ARG} && " )
      elseif ( ${_CMD} MATCHES POST )
        set ( _POST "${_POST} && ${_ARG}" )
      elseif ( ${_CMD} MATCHES PARAMS )
        set ( _PARAMS "${_PARAMS} ${_ARG}" )
      endif  ( ${_CMD} MATCHES PRE )
      set ( _CMD )
    endif ( ${ARG} MATCHES PRE )
  endforeach ( _ARG )

  if (_IGNOREOUT)
    set ( COMMAND "( ${TESTNAME_LOC} ${_PARAMS} > /dev/null )" )
  else (_IGNOREOUT)
    set ( COMMAND "( ${TESTNAME_LOC} ${_PARAMS} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out ) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out" )
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    add_test ( cppinstallcheck_${TESTNAME} "sh" "-c" "${_PRE}${COMMAND}${_POST}" )
  else (_PRE OR _POST)
    add_test ( cppinstallcheck_${TESTNAME} "sh" "-c" "${COMMAND}" )
  endif (_PRE OR _POST)
  set_tests_properties ( cppinstallcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${INSTALLCHECK_ENVIRONMENT}" )
  list ( APPEND INSTALLCHECK_TO_BE_RUN ${TESTNAME_TGT} )
  install ( FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH}
            PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
          )
endmacro ( ot_installcheck_test )

include_directories ( ${INTERNAL_INCLUDE_DIRS} )

## Pre-installation tests

# Common
ot_check_test ( Object_std )
ot_check_test ( OStream_std )
ot_check_test ( PersistentObject_std )
ot_check_test ( Pointer_std )
ot_check_test ( Pointer_cast )
ot_check_test ( Exception_std )
ot_check_test ( Log_std )
ot_check_test ( IdFactory_std IGNOREOUT )
ot_check_test ( ComparisonOperator_std )
ot_check_test ( Study_save IGNOREOUT )
ot_check_test ( Study_load IGNOREOUT )
ot_check_test ( ResourceMap_std IGNOREOUT )
ot_check_test ( Catalog_std IGNOREOUT )
ot_check_test ( AtomicFunctions_std IGNOREOUT )

# Type
ot_check_test ( Collection_std )
ot_check_test ( Domain_std )
ot_check_test ( Indices_std )
ot_check_test ( Interval_std )
ot_check_test ( Description_std )
ot_check_test ( NumericalPoint_std )
ot_check_test ( NumericalPoint_description )
ot_check_test ( Matrix_std )
ot_check_test ( IdentityMatrix_std )
ot_check_test ( Tensor_std )
ot_check_test ( SymmetricTensor_std )
ot_check_test ( SquareMatrix_std )
ot_check_test ( SymmetricMatrix_std )
ot_check_test ( MatrixSolveLinearSystem_std )
ot_check_test ( MatrixSingularValues_std )
ot_check_test ( SquareMatrixLapack_std )
ot_check_test ( SymmetricMatrixLapack_std )
ot_check_test ( Cache_std )
ot_check_test ( RegularGrid_std )
ot_check_test ( ComplexMatrix_std )
ot_check_test ( SquareComplexMatrix_std )
ot_check_test ( HermitianMatrix_std )
ot_check_test ( TriangularComplexMatrix_std )

# Func
ot_check_test ( LibraryLoader_std )
ot_check_test ( LinearNumericalMathEvaluationImplementation_std )
ot_check_test ( ConstantNumericalMathGradientImplementation_std )
ot_check_test ( LinearNumericalMathFunction_std )
ot_check_test ( LinearCombinationEvaluationImplementation_std )
ot_check_test ( LinearCombinationGradientImplementation_std )
ot_check_test ( LinearCombinationHessianImplementation_std )
ot_check_test ( QuadraticNumericalMathEvaluationImplementation_std )
ot_check_test ( LinearNumericalMathGradientImplementation_std )
ot_check_test ( ConstantNumericalMathHessianImplementation_std )
ot_check_test ( MethodBoundNumericalMathEvaluationImplementation_std )
ot_check_test ( NumericalMathFunction_analytical )
ot_check_test ( NumericalMathFunction_indicator )
ot_check_test ( NumericalMathFunction_dual_linear_combination )
ot_check_test ( NumericalMathFunction_linear_combination )
ot_check_test ( NumericalMathFunction_product )
ot_check_test ( NumericalMathFunction_data )
ot_check_test ( NumericalMathFunction_history )
ot_check_test ( UniVariatePolynomial_std )
ot_check_test ( Basis_std )
ot_check_test ( BasisSequence_std )
ot_check_test ( LAR_std )
ot_check_test ( DynamicalFunction_std )
ot_check_test ( SpatialFunction_std )
ot_check_test ( TemporalFunction_std )
ot_check_test ( BoxCoxEvaluationImplementation_std )
ot_check_test ( BoxCoxTransform_std )
ot_check_test ( InverseBoxCoxEvaluationImplementation_std )
ot_check_test ( InverseBoxCoxTransform_std )
ot_check_test ( TrendEvaluationImplementation_std )
ot_check_test ( TrendTransform_std )
ot_check_test ( InverseTrendEvaluationImplementation_std )
ot_check_test ( InverseTrendTransform_std )

# Optim
ot_check_test ( BoundConstrainedAlgorithmImplementationResult_std )

# Solver
ot_check_test ( Bisection_std )
ot_check_test ( Brent_std )
ot_check_test ( Secant_std )

# Stat
ot_check_test ( NumericalSample_std )
ot_check_test ( NumericalSample_split )
ot_check_test ( NumericalSample_large )
ot_check_test ( NumericalSample_computation )
ot_check_test ( HistoryStrategy_std )
ot_check_test ( CovarianceMatrixLapack_std )
ot_check_test ( CorrelationMatrix_std )
ot_check_test ( ConfidenceInterval_std )
ot_check_test ( TestResult_std )
ot_check_test ( LinearModelFactory_std )
ot_check_test ( LinearModel_std )
ot_check_test ( SensitivityAnalysis_std )
ot_check_test ( ProcessSample_std )
ot_check_test ( RandomGenerator_std )
ot_check_test ( SobolSequence_std )
ot_check_test ( FaureSequence_std )
ot_check_test ( HaltonSequence_std )
ot_check_test ( HaselgroveSequence_std )
ot_check_test ( ReverseHaltonSequence_std )
ot_check_test ( CorrelationAnalysis_std )
ot_check_test ( TimeSeries_std )
ot_check_test ( ExponentialCauchy_std )
ot_check_test ( FilteringWindows_std )
ot_check_test ( WelchFactory_std )
ot_check_test ( ExponentialModel_std )
ot_check_test ( CauchyModel_std )
ot_check_test ( SecondOrderModel_std )
ot_check_test ( UserDefinedSpectralModel_std )

# Graph
ot_check_test ( BarPlot_std )
ot_check_test ( Cloud_std )
ot_check_test ( Contour_std )
ot_check_test ( Curve_std )
ot_check_test ( Drawable_std )
ot_check_test ( Graph_mix )
ot_check_test ( Graph_export )
ot_check_test ( Pairs_std )
ot_check_test ( Pie_std )
ot_check_test ( Staircase_std )


# Algo
ot_check_test ( PenalizedLeastSquaresAlgorithm_std )
ot_check_test ( CorrectedLeaveOneOut_std )
ot_check_test ( KFold_std )
# ot_check_test ( Lasso_std )
# ot_check_test ( LassoFactory_std )
ot_check_test ( LeastSquaresMetaModelSelectionFactory_std )
ot_check_test ( KissFFT_std )

# Distribution
ot_check_test ( Arcsine_std )
ot_check_test ( ArcsineFactory_std )
ot_check_test ( Bernoulli_std )
ot_check_test ( BernoulliFactory_std )
ot_check_test ( Beta_std )
ot_check_test ( BetaFactory_std )
ot_check_test ( Binomial_std )
ot_check_test ( BinomialFactory_std )
ot_check_test ( Burr_std )
ot_check_test ( BurrFactory_std )
ot_check_test ( Chi_std )
ot_check_test ( ChiFactory_std )
ot_check_test ( ChiSquare_std )
ot_check_test ( ChiSquareFactory_std )

=== python/src/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

add_definitions ( -DSWIG_TYPE_TABLE=openturns )

# generate SWIG runtime header
set ( SWIG_PYTHON_OPTIONS "-python" )
add_custom_command ( OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/swig_runtime.hxx
                     COMMAND ${SWIG_EXECUTABLE}
                     ARGS ${SWIG_PYTHON_OPTIONS} ${CMAKE_SWIG_FLAGS} -external-runtime ${CMAKE_CURRENT_BINARY_DIR}/swig_runtime.hxx
                     COMMENT "SWIG runtime header generation" )
add_custom_target ( generate_swig_runtime DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/swig_runtime.hxx )
include_directories ( ${CMAKE_CURRENT_BINARY_DIR} )

include_directories ( ${INTERNAL_INCLUDE_DIRS} )
include_directories ( ${CMAKE_CURRENT_SOURCE_DIR} )

set ( OPENTURNS_PYTHON_MODULES )
macro ( ot_add_python_module MODULENAME SOURCEFILE )
  set_source_files_properties ( ${SOURCEFILE} PROPERTIES CPLUSPLUS ON )
  set_source_files_properties ( ${SOURCEFILE} PROPERTIES SWIG_MODULE_NAME ${MODULENAME} )
  ot_install_swig_file ( ${SOURCEFILE} )
  if ( ${ARGC} GREATER 2 )
    set ( SWIG_MODULE_${MODULENAME}_EXTRA_DEPS ${ARGN} )
  endif ( ${ARGC} GREATER 2 )

  if ( RPY2_FOUND )
    set ( SWIG_MODULE_${MODULENAME}_EXTRA_FLAGS "-DHAVE_PYTHON_PACKAGE_RPY2=1" )
  endif ( RPY2_FOUND )

  set ( swig_other_sources )
  foreach ( it ${ARGN} )
    if ( ${it} MATCHES ".*\\.i$" )
      ot_install_swig_file ( ${it} )
    else ( ${it} MATCHES ".*\\.i$" )
      set ( swig_other_sources ${swig_other_sources} "${it}" )
    endif ( ${it} MATCHES ".*\\.i$" )
  endforeach ( it )

  # workaround for a bug in UseSWIG script not supporting multiple modules and parallel compilation
  # http://www.cmake.org/pipermail/cmake/2011-January/042345.html
  if ( CMAKE_VERSION VERSION_LESS 2.8.5 )
    set( swig_extra_generated_files )
  endif ( CMAKE_VERSION VERSION_LESS 2.8.5 )
  swig_add_module ( ${MODULENAME} python ${SOURCEFILE} ${swig_other_sources} )

  add_dependencies ( ${SWIG_MODULE_${MODULENAME}_REAL_NAME} generate_swig_runtime )
  swig_link_libraries ( ${MODULENAME} OT ${PYTHON_LIBRARIES} )
  list ( APPEND OPENTURNS_PYTHON_MODULES ${MODULENAME} )
endmacro ( ot_add_python_module )



ot_install_header_file ( PythonNumericalMathEvaluationImplementation.hxx )
ot_install_header_file ( PythonWrappingFunctions.hxx )

#set_source_files_properties ( openturns_preload.c
#                              PROPERTIES COMPILE_FLAGS "-DLIBRARY_PATH=\\\"${LIBRARY_PATH}\\\"" )
#add_library( openturns_preload MODULE openturns_preload.c )
#set_target_properties ( openturns_preload PROPERTIES PREFIX "" )
#target_link_libraries ( openturns_preload OT )
#install ( TARGETS openturns_preload
#          LIBRARY DESTINATION ${OPENTURNS_PYTHON_MODULE_PATH}/openturns
#        )

ot_add_python_module ( common common_module.i
                              OTtypes.i
                              OTexceptions.i
                              Memory.i
                              Object.i
                              PersistentObject.i
                              Study.i
                              StorageManager.i
                              XMLStorageManager.i
                              Log.i
                              MPI.i
                              TTY.i
                              Path.i
                              Catalog.i
                              ResourceMap.i
                              ComparisonOperatorImplementation.i
                              ComparisonOperator.i
                              Equal.i
                              Greater.i
                              GreaterOrEqual.i
                              Less.i
                              LessOrEqual.i
                              Cache.i
                              Threadable.i
                              PlatformInfo.i
                              BoostPointerImplementation.i
                              SharedPointer.i
                              Pointer.i
                              InterfaceObject.i
                              TypedInterfaceObject.i
                              TypedCollectionInterfaceObject.i
                              BaseCommonTemplateDefs.i
                     )
ot_add_python_module ( wrapper wrapper_module.i
                               Collection.i
			       WrapperData.i
			       WrapperFile.i
			       BaseWrapperTemplateDefs.i
                     )
ot_add_python_module ( typ typ_module.i
                           PersistentCollection.i
			   DescriptionImplementation.i
			   Description.i
			   NumericalPoint.i
			   NumericalPointWithDescription.i
			   Indices.i
			   DomainImplementation.i
			   Domain.i
			   Interval.i
			   MatrixImplementation.i
			   Matrix.i
			   SquareMatrix.i
			   SymmetricMatrix.i
			   TensorImplementation.i
			   Tensor.i
			   SymmetricTensor.i
			   BaseTypTemplateDefs.i
			   ComplexMatrixImplementation.i
			   ComplexMatrix.i
			   HermitianMatrix.i 
			   SquareComplexMatrix.i
			   TriangularComplexMatrix.i
                     )
ot_add_python_module ( statistics statistics_module.i
                                  CovarianceMatrix.i
				  CorrelationMatrix.i
				  IdentityMatrix.i
				  NumericalSample.i
				  HistoryStrategyImplementation.i
				  HistoryStrategy.i
				  Compact.i
				  Full.i
				  Last.i
				  Null.i
				  ConfidenceInterval.i
				  LinearModel.i
                                  LinearModelFactory.i
                                  TestResult.i
				  ProcessSample.i
                                  RandomGenerator.i
                                  CorrelationAnalysis.i
                                  SensitivityAnalysis.i
                                  LowDiscrepancySequenceImplementation.i
				  LowDiscrepancySequence.i
				  SobolSequence.i
				  FaureSequence.i
				  HaltonSequence.i
				  HaselgroveSequence.i
				  ReverseHaltonSequence.i
				  TimeSeries.i
				  BaseStatisticsTemplateDefs.i
				  SecondOrderModelImplementation.i 
				  SecondOrderModel.i
				  ExponentialCauchy.i
				  FilteringWindowsImplementation.i
				  FilteringWindows.i
				  Hamming.i
				  Hanning.i
				  SpectralModelImplementation.i
				  SpectralModel.i
				  CovarianceModelImplementation.i
				  CovarianceModel.i
				  StationaryCovarianceModel.i
				  SpectralModelFactoryImplementation.i
				  SpectralModelFactory.i
				  UserDefinedSpectralModel.i
				  WelchFactory.i
				  ExponentialModel.i
				  CauchyModel.i
                     )
ot_add_python_module ( graph graph_module.i
                             DrawableImplementation.i
			     Drawable.i
			     GraphImplementation.i
			     Graph.i
			     BarPlot.i
                             Cloud.i
                             Contour.i
                             Curve.i
                             Pairs.i
                             Pie.i
                             Staircase.i
                             BaseGraphTemplateDefs.i
                     )
ot_add_python_module ( func func_module.i
                            SpecFunc.i
                            NumericalMathEvaluationImplementation.i
                            NumericalMathGradientImplementation.i
			    NumericalMathHessianImplementation.i
			    NoNumericalMathEvaluationImplementation.i
			    NoNumericalMathGradientImplementation.i
			    NoNumericalMathHessianImplementation.i
			    LinearNumericalMathEvaluationImplementation.i
			    LinearNumericalMathGradientImplementation.i
			    QuadraticNumericalMathEvaluationImplementation.i
			    ConstantNumericalMathGradientImplementation.i
			    ConstantNumericalMathHessianImplementation.i
			    ComputedNumericalMathEvaluationImplementation.i
			    ComputedNumericalMathGradientImplementation.i
			    ComputedNumericalMathHessianImplementation.i
                            ComposedNumericalMathEvaluationImplementation.i
                            ComposedNumericalMathGradientImplementation.i
                            ComposedNumericalMathHessianImplementation.i
                            DualLinearCombinationEvaluationImplementation.i
                            DualLinearCombinationGradientImplementation.i
                            DualLinearCombinationHessianImplementation.i
                            LinearCombinationEvaluationImplementation.i
                            LinearCombinationGradientImplementation.i
                            LinearCombinationHessianImplementation.i
			    ProductNumericalMathEvaluationImplementation.i
			    ProductNumericalMathGradientImplementation.i
			    ProductNumericalMathHessianImplementation.i
			    NumericalMathFunctionImplementation.i
			    ComposedNumericalMathFunction.i
			    ProductNumericalMathFunction.i
			    NumericalMathFunction.i
			    DynamicalFunctionImplementation.i
			    DynamicalFunction.i
			    SpatialFunction.i
			    TemporalFunction.i
			    LinearNumericalMathFunction.i
			    UniVariatePolynomialImplementation.i
                            UniVariatePolynomial.i
			    AggregatedNumericalMathEvaluationImplementation.i
			    AnalyticalNumericalMathEvaluationImplementation.i
			    DatabaseNumericalMathEvaluationImplementation.i
                            IndicatorNumericalMathEvaluationImplementation.i
                            ProductPolynomialEvaluationImplementation.i
                            Basis.i
                            BasisSequenceImplementation.i
                            BasisSequence.i
                            BasisSequenceFactoryImplementation.i
                            BasisSequenceFactory.i
                            LAR.i
                            LARLasso.i
                            LARFSZero.i
                            BaseFuncTemplateDefs.i 
			    BoxCoxEvaluationImplementation.i
                            BoxCoxTransform.i
			    InverseBoxCoxEvaluationImplementation.i
                            PythonNumericalMathEvaluationImplementation.cxx
			    InverseBoxCoxTransform.i
			    TrendEvaluationImplementation.i
			    TrendTransform.i
			    InverseTrendEvaluationImplementation.i
			    InverseTrendTransform.i
                     )

ot_add_python_module ( diff diff_module.i
                            FiniteDifferenceStepImplementation.i
                            FiniteDifferenceStep.i
                            ConstantStep.i
                            BlendedStep.i
                            FiniteDifferenceGradient.i
                            FiniteDifferenceHessian.i
                            CenteredFiniteDifferenceGradient.i
                            CenteredFiniteDifferenceHessian.i
                            NonCenteredFiniteDifferenceGradient.i
                            BaseDiffTemplateDefs.i
                     )

ot_add_python_module ( optim optim_module.i
                             BoundConstrainedAlgorithmImplementationResult.i
			     BoundConstrainedAlgorithmImplementation.i
			     BoundConstrainedAlgorithm.i
			     NearestPointAlgorithmImplementationResult.i

=== python/test/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  (C) Copyright 2005-2012 EDF-EADS-Phimeca
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License.
#
#  This library is distributed in the hope that it will be useful
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#  @author: $LastChangedBy: dutka $
#  @date:   $LastChangedDate: 2010-02-04 16:44:49 +0100 (Thu, 04 Feb 2010) $
#  Id:      $Id: Makefile.am 1473 2010-02-04 15:44:49Z dutka $
#

cmake_minimum_required ( VERSION 2.8 )

#include ( CTest )

set ( NEW_PATH "$ENV{PATH}:${EXAMPLE_PATH}" )

set ( PYINSTALLCHECK_ENVIRONMENT "OPENTURNS_WRAPPER_PATH=${WRAPPER_PATH}"
                                 "OPENTURNS_CONFIG_PATH=${SYSCONFIG_PATH}/openturns"
                                 "OPENTURNS_NUMERICALSAMPLE_PATH=${SAMPLE_PATH}"
                                 "PATH=${NEW_PATH}"
                                 "PYTHONPATH=${PYTHON_MODULE_PATH}"
    )

# This macro compiles on the fly and run the corresponding post-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set ( PYINSTALLCHECK_TO_BE_RUN )
macro ( ot_pyinstallcheck_test TESTNAME )
  set ( TESTNAME_TGT t_${TESTNAME} )
  set ( TESTNAME_SRC ${TESTNAME_TGT}.py )
  set ( TESTNAME_OUT ${TESTNAME_TGT}.expout )
  get_source_file_property ( OUTFILE_LOC ${TESTNAME_OUT} LOCATION )
  #add_executable ( ${TESTNAME_TGT} EXCLUDE_FROM_ALL ${TESTNAME_SRC} )
  #target_link_libraries ( ${TESTNAME_TGT} OT )
  get_source_file_property ( TESTNAME_LOC ${TESTNAME_SRC} LOCATION )

  set ( _CMD )
  set ( _PRE )
  set ( _POST )
  set ( _PARAMS )
  set ( _IGNOREOUT OFF )
  foreach ( _ARG ${ARGN} )
    string ( TOUPPER ${_ARG} ARG )
    if ( ${ARG} MATCHES PRE )
      set ( _CMD PRE )
    elseif ( ${ARG} MATCHES POST )
      set ( _CMD POST )
    elseif ( ${ARG} MATCHES PARAMS )
      set ( _CMD PARAMS )
    elseif ( ${ARG} MATCHES IGNOREOUT )
      set ( _IGNOREOUT ON )
    else ( ${ARG} MATCHES PRE )
      if ( ${_CMD} MATCHES PRE )
        set ( _PRE "${_PRE} ${_ARG} && " )
      elseif ( ${_CMD} MATCHES POST )
        set ( _POST "${_POST} && ${_ARG}" )
      elseif ( ${_CMD} MATCHES PARAMS )
        set ( _PARAMS "${_PARAMS} ${_ARG}" )
      endif  ( ${_CMD} MATCHES PRE )
      set ( _CMD )
    endif ( ${ARG} MATCHES PRE )
  endforeach ( _ARG )

  if (_IGNOREOUT)
    set ( COMMAND "( ${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} > /dev/null )" )
  else (_IGNOREOUT)
    set ( COMMAND "( ${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out ) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out" )
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    add_test ( pyinstallcheck_${TESTNAME} "sh" "-c" "${_PRE}${COMMAND}${_POST}" )
  else (_PRE OR _POST)
    add_test ( pyinstallcheck_${TESTNAME} "sh" "-c" "${COMMAND}" )
  endif (_PRE OR _POST)
  set_tests_properties ( pyinstallcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${PYINSTALLCHECK_ENVIRONMENT}" )
  list ( APPEND PYINSTALLCHECK_TO_BE_RUN ${TESTNAME_SRC} )
  install ( FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH} 
            PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
          )
endmacro ( ot_pyinstallcheck_test )


## Python post-installation tests

# Algo
ot_pyinstallcheck_test ( PenalizedLeastSquaresAlgorithm_std )
ot_pyinstallcheck_test ( KFold_std )
ot_pyinstallcheck_test ( CorrectedLeaveOneOut_std )
ot_pyinstallcheck_test ( LeastSquaresMetaModelSelectionFactory_std )
ot_pyinstallcheck_test ( KissFFT_std )

# Common
ot_pyinstallcheck_test ( ComparisonOperator_std )
ot_pyinstallcheck_test ( Path_std IGNOREOUT )
ot_pyinstallcheck_test ( ResourceMap_std IGNOREOUT )
ot_pyinstallcheck_test ( Catalog_std IGNOREOUT )

# Type
ot_pyinstallcheck_test ( Collection_std )
ot_pyinstallcheck_test ( Description_std )
ot_pyinstallcheck_test ( Indices_std )
ot_pyinstallcheck_test ( Interval_std )
ot_pyinstallcheck_test ( NumericalPoint_std )
ot_pyinstallcheck_test ( NumericalPoint_description )
ot_pyinstallcheck_test ( Matrix_std )
ot_pyinstallcheck_test ( SymmetricMatrixLapack_std )
ot_pyinstallcheck_test ( SquareMatrixLapack_std )
ot_pyinstallcheck_test ( SquareMatrix_std )
ot_pyinstallcheck_test ( SymmetricMatrix_std )
ot_pyinstallcheck_test ( Tensor_std )
ot_pyinstallcheck_test ( SymmetricTensor_std )
ot_pyinstallcheck_test ( MatrixSolveLinearSystem_std )
ot_pyinstallcheck_test ( MatrixSingularValues_std )
ot_pyinstallcheck_test ( IdentityMatrix_std )
ot_pyinstallcheck_test ( NumericalPoint_python )
ot_pyinstallcheck_test ( Domain_std )
ot_pyinstallcheck_test ( RegularGrid_std )
ot_pyinstallcheck_test ( ComplexMatrix_std )
ot_pyinstallcheck_test ( SquareComplexMatrix_std )
ot_pyinstallcheck_test ( HermitianMatrix_std )
ot_pyinstallcheck_test ( TriangularComplexMatrix_std )

# Func
ot_pyinstallcheck_test ( WrapperFile_std )
ot_pyinstallcheck_test ( NumericalMathFunction_std )
ot_pyinstallcheck_test ( NumericalMathFunction_grad )
ot_pyinstallcheck_test ( NumericalMathFunction_hess )
ot_pyinstallcheck_test ( NumericalMathFunction_sample )
ot_pyinstallcheck_test ( NumericalMathFunction_timeseries )
ot_pyinstallcheck_test ( NumericalMathFunction_composition )
ot_pyinstallcheck_test ( NumericalMathFunction_exec )
ot_pyinstallcheck_test ( NumericalMathFunction_exec_external PARAMS "system=LINUX" PRE "cp ${CMAKE_CURRENT_SOURCE_DIR}/poutre_external_infile1 ${CMAKE_CURRENT_SOURCE_DIR}/poutre_external_infile2 ${CMAKE_CURRENT_BINARY_DIR}" POST "rm -f ${CMAKE_CURRENT_BINARY_DIR}/poutre_external_infile1 ${CMAKE_CURRENT_BINARY_DIR}/poutre_external_infile2 ${CMAKE_CURRENT_BINARY_DIR}/poutre_external_outfile" )
ot_pyinstallcheck_test ( NumericalMathFunction_exec_sample )
ot_pyinstallcheck_test ( NumericalMathFunction_exec_threads )
ot_pyinstallcheck_test ( NumericalMathFunction_minimal )
ot_pyinstallcheck_test ( NumericalMathFunction_python )
ot_pyinstallcheck_test ( NumericalMathFunction_python_save IGNOREOUT )
ot_pyinstallcheck_test ( NumericalMathFunction_python_load IGNOREOUT )
ot_pyinstallcheck_test ( NumericalMathFunction_wrapper_error )
ot_pyinstallcheck_test ( NumericalMathFunction_data )
ot_pyinstallcheck_test ( NumericalMathFunction_history )
ot_pyinstallcheck_test ( LinearNumericalMathEvaluationImplementation_std )
ot_pyinstallcheck_test ( LinearNumericalMathFunction_std )
ot_pyinstallcheck_test ( LinearCombinationEvaluationImplementation_std )
ot_pyinstallcheck_test ( LinearCombinationGradientImplementation_std )
ot_pyinstallcheck_test ( LinearCombinationHessianImplementation_std )
ot_pyinstallcheck_test ( QuadraticNumericalMathEvaluationImplementation_std )
ot_pyinstallcheck_test ( LinearNumericalMathGradientImplementation_std )
ot_pyinstallcheck_test ( NumericalMathFunction_analytical )
ot_pyinstallcheck_test ( NumericalMathFunction_dual_linear_combination )
ot_pyinstallcheck_test ( NumericalMathFunction_indicator )
ot_pyinstallcheck_test ( NumericalMathFunction_linear_combination )
ot_pyinstallcheck_test ( ConstantNumericalMathGradientImplementation_std )
ot_pyinstallcheck_test ( ConstantNumericalMathHessianImplementation_std )
ot_pyinstallcheck_test ( MergeRandomAndConstantInput )
ot_pyinstallcheck_test ( Basis_std )
ot_pyinstallcheck_test ( BasisSequence_std )
ot_pyinstallcheck_test ( LAR_std )
ot_pyinstallcheck_test ( DynamicalFunction_std )
ot_pyinstallcheck_test ( SpatialFunction_std )
ot_pyinstallcheck_test ( TemporalFunction_std )
ot_pyinstallcheck_test ( BoxCoxEvaluationImplementation_std )
ot_pyinstallcheck_test ( BoxCoxTransform_std )
ot_pyinstallcheck_test ( InverseBoxCoxEvaluationImplementation_std )
ot_pyinstallcheck_test ( InverseBoxCoxTransform_std )
ot_pyinstallcheck_test ( TrendEvaluationImplementation_std )
ot_pyinstallcheck_test ( TrendTransform_std )
ot_pyinstallcheck_test ( InverseTrendEvaluationImplementation_std )
ot_pyinstallcheck_test ( InverseTrendTransform_std )

# Stat
ot_pyinstallcheck_test ( NumericalSample_std )
ot_pyinstallcheck_test ( NumericalSample_computation )
ot_pyinstallcheck_test ( NumericalSample_split )
ot_pyinstallcheck_test ( NumericalSample_large )
ot_pyinstallcheck_test ( NumericalSample_bug14 )
ot_pyinstallcheck_test ( NumericalSample_csv )
ot_pyinstallcheck_test ( HistoryStrategy_std )
ot_pyinstallcheck_test ( CovarianceMatrixLapack_std )
ot_pyinstallcheck_test ( CorrelationMatrix_std )
ot_pyinstallcheck_test ( LinearModel_std )
ot_pyinstallcheck_test ( LinearModelFactory_std )
ot_pyinstallcheck_test ( ProcessSample_std )
ot_pyinstallcheck_test ( RandomGenerator_std )
ot_pyinstallcheck_test ( SobolSequence_std )
ot_pyinstallcheck_test ( FaureSequence_std )
ot_pyinstallcheck_test ( HaltonSequence_std )
ot_pyinstallcheck_test ( HaselgroveSequence_std )
ot_pyinstallcheck_test ( ReverseHaltonSequence_std )
ot_pyinstallcheck_test ( TestResult_std )
ot_pyinstallcheck_test ( ConfidenceInterval_std )
ot_pyinstallcheck_test ( SensitivityAnalysis_std )
ot_pyinstallcheck_test ( CorrelationAnalysis_std )
ot_pyinstallcheck_test ( TimeSeries_std )
ot_pyinstallcheck_test ( ExponentialCauchy_std )
ot_pyinstallcheck_test ( FilteringWindows_std )
ot_pyinstallcheck_test ( WelchFactory_std )
ot_pyinstallcheck_test ( ExponentialModel_std )
ot_pyinstallcheck_test ( CauchyModel_std )
ot_pyinstallcheck_test ( SecondOrderModel_std )
ot_pyinstallcheck_test ( UserDefinedSpectralModel_std )

## Graph
ot_pyinstallcheck_test ( BarPlot_std )
ot_pyinstallcheck_test ( Cloud_std )
ot_pyinstallcheck_test ( Contour_std )
ot_pyinstallcheck_test ( Curve_std )
ot_pyinstallcheck_test ( Drawable_std )
ot_pyinstallcheck_test ( Graph_export )
ot_pyinstallcheck_test ( Graph_mix )
ot_pyinstallcheck_test ( Pairs_std )
ot_pyinstallcheck_test ( Pie_std )
ot_pyinstallcheck_test ( Staircase_std )

## Diff
ot_pyinstallcheck_test ( FiniteDifferenceStep_std )
ot_pyinstallcheck_test ( CenteredFiniteDifferenceGradient_std )
ot_pyinstallcheck_test ( CenteredFiniteDifferenceHessian_std )
ot_pyinstallcheck_test ( NonCenteredFiniteDifferenceGradient_std )

## Optim
ot_pyinstallcheck_test ( AbdoRackwitz_std )
ot_pyinstallcheck_test ( AbdoRackwitz_linear )
ot_pyinstallcheck_test ( AbdoRackwitz_nonlinear )
ot_pyinstallcheck_test ( NearestPointChecker_std )
ot_pyinstallcheck_test ( Cobyla_std )
ot_pyinstallcheck_test ( Cobyla_linear )
ot_pyinstallcheck_test ( Cobyla_nonlinear )
ot_pyinstallcheck_test ( SQP_std )
ot_pyinstallcheck_test ( SQP_linear )
ot_pyinstallcheck_test ( SQP_nonlinear )
ot_pyinstallcheck_test ( BoundConstrainedAlgorithmImplementationResult_std )
ot_pyinstallcheck_test ( TNC_std )
ot_pyinstallcheck_test ( TNC_linear )
ot_pyinstallcheck_test ( TNC_nonlinear )

## Solver
ot_pyinstallcheck_test ( Brent_std )
ot_pyinstallcheck_test ( Bisection_std )
ot_pyinstallcheck_test ( Secant_std )

## Model
ot_pyinstallcheck_test ( Event_std )
ot_pyinstallcheck_test ( StandardEvent_std )
ot_pyinstallcheck_test ( RandomVector_constant )
ot_pyinstallcheck_test ( RandomVector_distribution )
ot_pyinstallcheck_test ( RandomVector_function )
ot_pyinstallcheck_test ( RandomVector_conditional )

## Process
ot_pyinstallcheck_test ( WhiteNoise_std )
ot_pyinstallcheck_test ( RandomWalk_std )
ot_pyinstallcheck_test ( ARMAState_std )
ot_pyinstallcheck_test ( ARMACoefficients_std )

=== debian/changelog ===
openturns (1.0-4) unstable; urgency=low

  [ Denis Barbier ]
  * debian/patches/test-output.patch: New patch.
    Fix test output, some compilers print 'df(x)=' twice because
    exception is thrown after text is printed to stdout.
  * debian/patches/ftbfs-clang.patch: New patch.
    Allows building with the clang compiler.
  * debian/patches/fix-bigendian.patch: New patch.
    Many checks fail on some (but not all) big endian machines,
    it seems that not all systems define __BIG_ENDIAN__.
    Add some compile-time checks to determine endianness.
  * debian/rules: Do not ignore test results for architectures
    on which tests currently pass.
  * debian/rules: Also compile algocobyla.c with -fno-cse-follow-jumps
    on kfreebsd-i386 and hurd-i386, one test hangs as on i386.
  * debian/rules: On mipsel, do not build Python libraries in
    parallel to avoid build failures due to memory problems.

 -- Denis Barbier <barbier@debian.org>  Fri, 15 Jun 2012 20:45:14 +0200

openturns (1.0-3) unstable; urgency=low

  [ Denis Barbier ]
  * debian/control: Fix dependency on r-other-rot, packages
    were not installable.
  * debian/patches/bigendian-randomgenerator.patch: New patch.
    Fix t_RandomGenerator_std unit test, it fails on PowerPC
    because of endianness.
  * debian/patches/cmake-tools.patch: New patch.
    Scripts openturns-config and openturns-module were broken.
  * Cleanup debian/patches by removing obsolete patches.  Also
    rewrite patch headers to follow DEP3.

 -- Denis Barbier <barbier@debian.org>  Sat, 19 May 2012 19:39:30 +0200

openturns (1.0-2) unstable; urgency=low

  [ Denis Barbier ]
  * debian/control: Fix dependency on tbb, it is available only on
    amd64, i386 and ia64.
  * debian/rules: Display output of failed tests to help debug failures.
  * debian/rules: Do not abort if tests fail; this was the behaviour
    when compiling with Autotools.

 -- Denis Barbier <barbier@debian.org>  Thu, 17 May 2012 17:43:20 +0200

openturns (1.0-1) experimental; urgency=low

  [ Christophe Trophime ]
  * debian/rules:
      explicit python version in override_dh_auto_configure target
  * debian/copyright:
      fix lintian warning

  [ Denis Barbier ]
  * New upstream release (Closes: #669425).
  * Build with g++ 4.6, several tests fail with g++ 4.7.
  * debian/patches/ftbfs-4.7.patch: Patch upgraded, previous
    fix had been applied upstream but there is another error.
  * debian/patches/debian-soname.patch: New patch.
    Use a Debian specific SONAME (0.1), upstream does
    not yet take care of SONAME.
    Rename libopenturns0 package into libopenturns0.1.
  * debian/patches/no-link-python.patch: New patch.
    Bugfix: "python-openturns is unusable" (Closes: #670066)
  * debian/rules: Compile algocobyla.c with -fno-cse-follow-jumps
    to work around an undefined GCC bug which makes one test
    hang on x86.  (Closes: #666782)
  * Do not build-depends on doxygen-latex, docbook-to-man.
  * Build-depends on bison, flex and bc (the latter is needed to run
    one test).
  * Move rotRpackage into a new binary package: r-other-rot, and
    let libopenturns0.1 depend on this package.  (Closes: #662800)
  * Install files into versioned directories /usr/lib/openturns-1.0
    and /etc/openturns-1.0 to avoid file conflicts during library
    transitions.
  * Add myself to Uploaders.

  [ Julien Schueller ]
  * Remove openturns-wrapper package, its files are now shipped
    by libopenturns0, libopenturns-dev and openturns-examples.
  * Moved dtd files to libopenturns0
  * Added missing generic wrapper to libopenturns0
  * Added python-openturns-dev
  * Added dependency to libtbb

 -- Denis Barbier <barbier@debian.org>  Wed, 16 May 2012 20:03:53 +0200

openturns (0.15-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "ftbfs with GCC-4.7": add patch from Denis Barbier: move declaration
    of streamObject before first usage.
    (Closes: #667315)

 -- gregor herrmann <gregoa@debian.org>  Sat, 21 Apr 2012 13:54:09 +0200

openturns (0.15-3) unstable; urgency=low

  * Team upload. (Closes: #662792).
  * Getting rid of unneeded *.la (Closes: #622492).
  * Transition to dh_python2 (Closes: #616928).
  * Use dh rules.tiny, enable parallel build.

 -- Aron Xu <aron@debian.org>  Mon, 26 Mar 2012 08:40:35 +0000

openturns (0.15-2) unstable; urgency=low

  * openturns-wrappers: install wrappers, wrapper.xml and wrapper.dtd

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 09 Sep 2011 06:34:05 +0200

openturns (0.15-1) unstable; urgency=low

  * New upstream release

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 30 Aug 2011 12:12:18 +0200

openturns (0.13.2-8) unstable; urgency=low

  * debian/control: add python-qt4 depends to python-openturns and
    openturns-examples now depends on python-openturns

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 28 Dec 2010 16:12:44 +0100

openturns (0.13.2-7) unstable; urgency=low

  [Christophe Prud'homme]
  * Bug fix: "creates a mess in sys.path by adding its own namespace",
    thanks to Bernd Zeimetz (Closes: #606870).
  * Bug fix: "Preparations for the removal of the KDE3 and Qt3 libraries",
    thanks to Eckhart Wörner (Closes: #604605).

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 28 Dec 2010 08:14:21 +0100

openturns (0.13.2-6) unstable; urgency=low

  [Christophe Prud'homme]
  * debian/rules: reduce optimization level to O1 on armel

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 13 Aug 2010 15:44:53 +0200

openturns (0.13.2-5) unstable; urgency=low

  [Christophe Prud'homme]
  * Bug fix: "FTBFS with Python 2.6: Could not link test program to
    Python.", thanks to Jakub Wilk (Closes: #586351).

 -- Christophe Prud'homme <prudhomm@debian.org>  Sat, 19 Jun 2010 07:22:38 +0200

openturns (0.13.2-4) unstable; urgency=low

  * Bug fix: "ftbfs with gcc-4.5", thanks to Matthias Klose (Closes:
    #565081).

 -- Christophe Prud'homme <prudhomm@debian.org>  Wed, 09 Jun 2010 21:55:51 +0200



=== debian/control ===
Source: openturns
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Denis Barbier <barbier@debian.org>
Build-Depends: debhelper (>= 8), quilt, g++-4.6, gfortran-4.6, bison, flex, libxml2-dev, liblapack-dev, libblas-dev, libtbb-dev [i386 amd64 ia64], r-base-core, python-dev, python-rpy2, ghostscript, graphviz, swig, cmake, bc
Standards-Version: 3.9.3
Homepage: http://trac.openturns.org/
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/openturns/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/openturns/trunk
X-Python-Version: current

Package: libopenturns0.1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, r-other-rot (= ${binary:Version})
Suggests: python-openturns
Replaces: openturns-wrapper
Breaks: openturns-wrapper
Description: dynamic libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * define the outputs of interest and decision criteria;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides the dynamic libraries.
 .
 The library implements almost all the treatments of uncertainty that
 OpenTURNS can provide. It is designed to be linked against any user
 specific application, or with either the textual front-end (see
 python-openturns package).
 .
 The main function of that library is giving to specific applications
 all the functionalities needed to treat uncertainties in
 studies. Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.

Package: libopenturns-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libopenturns0.1 (= ${binary:Version})
Replaces: openturns-wrapper
Breaks: openturns-wrapper
Description: headers and development libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides the OpenTURNS headers should be used if one
 wants to link its application against the library.

Package: libopenturns-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, libopenturns-dev
Description: debug symbols for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides the debug symbols of the OpenTurns libraries to
 help with debugging either your applications or OpenTURNS

Package: python-openturns
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenturns0.1 (= ${binary:Version}), ${python:Depends}, python-rpy2, ghostscript, python-qt4
Provides: ${python:Provides}
Description: Python front-end of OpenTURNS (aka TUI)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides a textual user interface that gives access to
 all the functionalities provided by the OpenTURNS library.

Package: python-openturns-dev
Section: python
Architecture: any
Depends: ${misc:Depends}, libopenturns-dev, python-openturns (= ${binary:Version}), python-dev
Replaces: libopenturns-dev
Breaks: libopenturns-dev (<< 1.0)
Description: Python front-end of OpenTURNS (aka TUI)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides development files for python modules.

Package: r-other-rot
Section: gnu-r
Architecture: any
Depends: ${misc:Depends}, r-base-core
Replaces: python-openturns
Breaks: python-openturns (<< 1.0)
Description: GNU R package of few tools needed by OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides R files needed by some OpenTURNS objects.

Package: openturns-examples
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python-openturns (= ${binary:Version}), libopenturns-dev
Replaces: openturns-wrapper
Breaks: openturns-wrapper
Description: examples of OpenTURNS functionalities
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides examples which are written either in C++ or in
 Python.
 .
 They are primarly used as validation tests for the whole
 platform but they can also be seen as tutorials for
 beginners.

Package: openturns-validation
Section: science
Architecture: all
Depends: ${misc:Depends}
Description: validation files for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package includes many maple input files that validates the
 results and the algorithms of OpenTURNS in a mathematical sense.

=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(findstring parallel=,$(DEB_BUILD_OPTIONS)),)
	export DEB_BUILD_OPTIONS+=parallel=$(shell getconf _NPROCESSORS_ONLN)
endif
$(info DEB_BUILD_OPTIONS:$(origin DEB_BUILD_OPTIONS)=$(DEB_BUILD_OPTIONS))

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	test_makeflags = -j$(NUMJOBS)
endif

cflags := $(shell dpkg-buildflags --get CFLAGS)
cxxflags := $(shell dpkg-buildflags --get CXXFLAGS)
fflags := $(shell dpkg-buildflags --get FFLAGS)
ldflags := $(shell dpkg-buildflags --get LDFLAGS)
ldflags += -Wl,--as-needed

ifeq ($(shell dpkg --print-architecture),armel)
    cflags := $(subst -O2,-O1,$(cflags))
    cxxflags := $(subst -O2,-O1,$(cxxflags))
    fflags := $(subst -O2,-O1,$(fflags))
endif
ifeq ($(shell dpkg --print-architecture),armhf)
    cflags := $(subst -O2,-O1,$(cflags))
    cxxflags := $(subst -O2,-O1,$(cxxflags))
    fflags := $(subst -O2,-O1,$(fflags))
endif
ifneq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), i386 kfreebsd-i386 hurd-i386))
    cflags += -fno-cse-follow-jumps
endif
ifneq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), i386 amd64 ia64))
    with_tbb := -DUSE_TBB:BOOL=ON
else
    with_tbb := -DUSE_TBB:BOOL=OFF
endif

# On those architectures, all tests pass with 1.0-3
arches_with_validated_tests := i386 amd64 kfreebsd-i386 kfreebsd-amd64
# Should be fixed after applying debian/patches/test-output.patch:
#  alpha armel armhf ia64 powerpc ppc64
# Failed tests need investigations; several failures may get fixed by fix-bigendian.patch
#  mips sparc
ifeq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), $(arches_with_validated_tests)))
    disable_runtime_tests := || true
endif

# Explicitly set builddir directory
builddir := obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

debRlib := $(CURDIR)/debian/tmp/usr/lib/R/site-library
export R_LIBS=$(debRlib)
PYVER = $(shell pyversions -dv)

%:
	dh $@ --buildsystem=cmake --builddirectory=$(builddir) --with python2 --with quilt --parallel

debian/tmp/usr/lib/R/site-library/rotRPackage:
	-mkdir -p $(debRlib)
	R CMD INSTALL --library=$(debRlib) utils/rotRPackage_1.4.4.tar.gz

override_dh_auto_configure: debian/tmp/usr/lib/R/site-library/rotRPackage
	dh_auto_configure -- \
            $(with_tbb) \
            -DCMAKE_CXX_COMPILER:FILEPATH=/usr/bin/g++-4.6 \
            -DCMAKE_Fortran_COMPILER:FILEPATH=/usr/bin/gfortran-4.6 \
            -DCMAKE_C_COMPILER:FILEPATH=/usr/bin/gcc-4.6 \
            -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
            -DCMAKE_C_FLAGS_RELWITHDEBINFO:STRING='$(cflags)' \
            -DCMAKE_CXX_FLAGS_RELWITHDEBINFO:STRING='$(cxxflags)' \
            -DCMAKE_Fortran_FLAGS_RELWITHDEBINFO:STRING='$(fflags)' \
            -DCMAKE_MODULE_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(ldflags)' \
            -DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DOPENTURNS_LIBRARY_PATH:PATH=lib \
            -DOPENTURNS_SYSCONFIG_PATH:PATH=/etc/openturns-1.0 \
            -DOPENTURNS_WRAPPER_PATH:PATH=lib/openturns-1.0/wrappers \
            -DOPENTURNS_SYSTEM_INSTALL:BOOL=ON \
            -DINSTALL_DESTDIR:PATH=$(CURDIR)/debian/tmp \
            -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/python \
            -DPYTHON_INCLUDE_DIR:PATH=/usr/include/python$(PYVER) \
            -DPYTHON_LIBRARY:PATH=/usr/lib/python$(PYVERS)/config/libpython$(PYVER).so

ifeq ($(shell dpkg --print-architecture),mipsel)
override_dh_auto_build:
	$(MAKE) $(test_makeflags) -C $(builddir)/lib
	$(MAKE) -j1 -C $(builddir)/python
	$(MAKE) $(test_makeflags) -C $(builddir)
endif

override_dh_auto_install: debian/tmp/usr/lib/R/site-library/rotRPackage
	dh_auto_install
	-mkdir -p debian/tmp/usr/share/openturns/m4
	cp lib/m4/*.m4 debian/tmp/usr/share/openturns/m4
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	CTEST_OUTPUT_ON_FAILURE=1 $(MAKE) $(test_makeflags) -C $(builddir) installcheck $(disable_runtime_tests)
endif
	#  Fix script permissions
	chmod a+x debian/tmp/usr/share/openturns/WrapperTemplates/wrapper_*/customize debian/tmp/usr/share/openturns/WrapperTemplates/wrapper_*/bootstrap

override_dh_makeshlibs:
	dh_makeshlibs -Xpyshared

override_dh_strip:
	dh_strip -plibopenturns0.1 --dbg-package=libopenturns-dbg
	dh_strip

override_dh_python2:
	dh_python2 --no-guessing-versions

override_dh_compress:
	dh_compress -X.pdf -X.svn -X.py

override_dh_auto_test:
	# Call 'make check' explicitly, 'make test' does not build binary tests
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	CTEST_OUTPUT_ON_FAILURE=1 $(MAKE) $(test_makeflags) -C $(builddir) check $(disable_runtime_tests)
endif

override_dh_auto_clean:
	dh_auto_clean
	-rm -f python/test/PyNMF.pyc python/test/PyNMF.pyo

get-orig-source:
	uscan --force-download --verbose
	mv ../openturn*.tar.[gzbz2]* ../tarballs

=== debian/watch ===
version=3
http://sf.net/openturns/openturns-([\d.]+)\.tar\.gz
